## opencpn 5.6.0+dfsg1

=== CMakeLists.txt ===
# ---------------------------------------------------------------------------
# Author:      Dave Register DEB
# config from: antonm - Anton Martchukov <anton@martchukov.com>
# Update:      sethdart (Jean-Eudes Onfray)
#                 with parts from balp (Anders Arnholm)
# ***************************************************************************
# - Copyright (C) 2010 by David S. Register                               *
# - This program is free software; you can redistribute it and/or modify  *
# - it under the terms of the GNU General Public License as published by  *
# - the Free Software Foundation; either version 2 of the License, or     *
# - (at your option) any later version.                                   *
# - *
# - This program is distributed in the hope that it will be useful,       *
# - but WITHOUT ANY WARRANTY; without even the implied warranty of        *
# - MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
# - GNU General Public License for more details.                          *
# - *
# - You should have received a copy of the GNU General Public License     *
# - along with this program; if not, write to the                         *
# - Free Software Foundation, Inc.,                                       *
# - 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,  USA.         *
# ***************************************************************************

#[[

Configuring opencpn
===================

Help:
    Opencpn configuration options can be listed using
        cmake -LH  | grep -B1 OCPN_

Renamed options:
    From version 5.0.0 all OpenCPN configuration options have a OCPN_ prefix
    Many older options are renamed, some examples:

        ENABLE_SYSTEM_CMD_SOUND -> OCPN_ENABLE_SYSTEM_CMD_SOUND
        USE_BUNDLED_LIBS -> OCPN_USE_BUNDLED_LIBS
        BUNDLE_DOCS ->  OCPN_BUNDLE_DOCS
        BUNDLE_TCDATA -> OCPN_BUNDLE_TCDATA
        ENABLE_PORTAUDIO -> OCPN_ENABLE_PORTAUDIO
        USE_GARMINHOST -> OCPN_USE_GARMINHOST
        ENABLE_CPPCHECK -> OCPN_ENABLE_CPPCHECK


Installation paths:
  - Since 5.0.0 OpenCPN supports the GNU install paths, see
    https://cmake.org/cmake/help/v3.0/module/GNUInstallDirs.html
  - Use CMAKE_INSTALL_LIBDIR to change the base directory for plugins;
    defaults to library location on most platforms, but is 'lib' on
    Debian.

Sound:
  - Without options, defaults to MswSound on Windows, PortAudioSound
    on Linux and WxSound on OSX.
  - With OCPN_ENABLE_SYSTEM_CMD_SOUND enabled SystemCmdSound will be the
    backend used on all platforms.
  - With OCPN_ENABLE_PORTAUDIO activated PortAudioSound can be used on all
    platforms if the necessary headers and libraries are available.
  - OCPN_ENABLE_SNDFILE adds libsndfile support to portaudio. libsndfile
    supports a wide range of audio formats instead of .wav only.

Bundled libraries:
  - OCPN_USE_BUNDLED_LIBS forces use of external/bundled libraries including
    wxsvg and liblz4. It's either:
      - ON => use all bundled libraries.
      - OFF => Always use external (system) libraries if available.
      - A comma-separated list of libraries where the bundled variant
        should be used. For other libraries, system libs is preferred.
  - If found, the system tinyxml library is used unconditionally.

Documentation:
  - OCPN_BUNDLE_DOCS governs inclusion of docs in the package.
  - Note that documentation is available in a separate download from
    opencpn website.


Tidal/current wallpaper
  - OCPN_BUNDLE_TCDATA (boolean) includes tide/current harmonics data in
    package.

GSHHS charts
  - OCPN_BUNDLE_GSHHS (boolean) includes gshhs charts in package

To build for android, use something like:
    $cmake -DUSE_GARMINHOST=OFF
        -D_wx_selected_config=androideabi-qt
        -DCMAKE_TOOLCHAIN_FILE=../buildandroid/build_android.cmake
        -DwxQt_Build=build_android_53
        -DwxQt_Base=/home/dsr/Projects/wxqt/wxWidgets
        -DQt_Base /home/dsr/Qt/5.3)
        ..

Silent/Verbose builds:
    cmake's handling of these issues is underwhelming. On most platforms the
    builds are by default verbose. Use 'cmake OCPN_VERBOSE=OFF' to make
    a silent build. The OCPN_VERBOSE value can be overridden using
    'make VERBOSE=1' or 'make -s'
#]]
#[[
TODO:
- Profiling opt
- test with Win & OSX
USE_GLU_TESS
USE_GLU_DLL
I also find it deficient in some areas. For instance, I cannot make it
output a VS project with certain compile switches set as desired,
namely /MT vs /MD. This means I must manually set this and other compiler
options after the CMake step. Sometimes I forget. Grrr...
set /MT for Release build, and /MTd for debug.
Is this still problem? If so, generator expressions seem to be the solution.
#]]

cmake_minimum_required(VERSION 3.1.1)
cmake_policy(SET CMP0043 NEW)
cmake_policy(SET CMP0025 NEW)
if (POLICY CMP0057)
  cmake_policy(SET CMP0057 NEW)
endif ()
if (POLICY CMP0077)
  cmake_policy(SET CMP0077 NEW)
endif ()

# Prefer libGL.so to libOpenGL.so, see CMP0072
set(OpenGL_GL_PREFERENCE "LEGACY")

project(OpenCPN)

if (NOT DEFINED OCPN_VERBOSE OR OCPN_VERBOSE)
  set(CMAKE_VERBOSE_MAKEFILE ON)
endif ()

message(STATUS "cmake version: ${CMAKE_VERSION}")

if (APPLE)
  set(PACKAGE_NAME OpenCPN)
else (APPLE)
  set(PACKAGE_NAME opencpn)
endif (APPLE)

# Locations where cmake looks for cmake modules.
set(
  CMAKE_MODULE_PATH
  ${CMAKE_SOURCE_DIR}/build
  ${CMAKE_SOURCE_DIR}/
  ${CMAKE_SOURCE_DIR}/cmake
)

if ("${OCPN_TARGET_TUPLE}" MATCHES "Android")
   message(STATUS "Building for wxQt-Android")
   set(QT_ANDROID "ON")
   if(PKG_ARCH STREQUAL "arm64")
     add_definitions("-DANDROID_ARM64")
   else ()
     add_definitions("-DANDROID_ARMHF")
   endif ()
   set(PACKAGE_NAME gorp)
endif ()


include(FindPkgConfig)
include(CMakeDependentOption)
include(CheckSymbolExists)

#
# Options
#

macro (BUNDLE_DOCS_OPT onoff)
  option(OCPN_BUNDLE_DOCS "Include documentation in package" ${onoff})
endmacro (BUNDLE_DOCS_OPT)

macro (BUNDLE_TCDATA_OPT onoff)
  option(
    OCPN_BUNDLE_TCDATA "Include tide/current harmonics data in package"
    ${onoff}
  )
endmacro (BUNDLE_TCDATA_OPT)

macro (BUNDLE_GSHHS_OPT onoff)
    option(OCPN_BUNDLE_GSHHS "Bundle minimal GSHHS data files" ${onoff})
endmacro (BUNDLE_GSHHS_OPT)

# If on Windows or Apple, build the monolithic package, to override use a non-
# sense values from the commandline (due to cmake inability to distinguish
# between not set and set to FALSE): cmake -DOCPN_BUNDLE_DOCS=BLAH
# -DOCPN_BUNDLE_TCDATA=BLAH

# Bundle tcdata and gshhs by default also on linux, to keep the defaults
# close to the official Debian package.
bundle_gshhs_opt("ON")
bundle_tcdata_opt("ON")

if (APPLE OR WIN32)
  bundle_docs_opt("ON")
else (APPLE OR WIN32)
  bundle_docs_opt("OFF")
endif (APPLE OR WIN32)


option(OCPN_VERBOSE "Make verbose builds"  ON)
option(OCPN_PEDANTIC "Enable more compiler warnings" OFF)

set(OCPN_PACKAGE_RELEASE "1" CACHE STRING "Package release number")

option(OCPN_USE_GL "Enable OpenGL support" ON)
option(OCPN_USE_GLES_SHIM "Enable GLESv1 Shim library" OFF)
option(OCPN_USE_UDEV_PORTS "Use udev to enumerate serial ports" ON)
option(OCPN_USE_SYSFS_PORTS "Use sysfs to enumerate serial ports" OFF)

set(OCPN_TARGET_TUPLE "" CACHE STRING
  "List of target;version;arch like flatpak;20.08;aarch64 [\"\"]"
)

if (MSVC OR MINGW)
  option(OCPN_USE_CRASHREPORT "Enable crash reporting" ON)
else ()
  set(OCPN_USE_CRASHREPORT FALSE)
endif ()

if (NOT WIN32 AND NOT APPLE AND NOT QT_ANDROID)
  find_library(GTK2U NAMES wx_gtk2u_core)
  if (GTK2U)
    option(OCPN_FORCE_GTK3 "Force the build to use GTK3 [OFF]" "OFF")
  else ()
    option(OCPN_FORCE_GTK3 "Force the build to use GTK3 [ON]" "ON")
  endif ()
endif ()

if (NOT WIN32 AND NOT APPLE AND NOT CMAKE_SYSTEM_PROCESSOR MATCHES "arm*")
  set(PA_DEFAULT "ON")
else ()
  set(PA_DEFAULT "OFF")
endif ()
option(
  OCPN_ENABLE_PORTAUDIO "Use portaudio(3) to play sounds if available"
  ${PA_DEFAULT}
)
cmake_dependent_option(
  OCPN_ENABLE_SNDFILE
  "Use libsndfile for portaudio if available."
  ON
  "OCPN_ENABLE_PORTAUDIO"
  ON
)

option(OCPN_USE_GARMINHOST "Enable Garmin Host Mode support" ON)

set(
  OCPN_WXWIDGETS_FORCE_VERSION
  CACHE STRING "Force usage of a specific wxWidgets version."
)

set(
  OCPN_WXWIDGETS_OPTIONS
  CACHE STRING "Additional flags to wxWidgets_CONFIG_OPTIONS"
)

if (WIN32 AND NOT UNIX)
  option(OCPN_BUNDLE_WXDLLS "Bundle the prebuilt WX DLLs" ON)
  option(OCPN_BUNDLE_VCDLLS "Bundle the VC redistributable libraries" ON)
  option(
    BUNDLE_LIBARCHIVEDLLS "Bundle the prebuilt LibArchive and LibLZMA DLLs" ON
  )
endif ()

if (CMAKE_VERSION VERSION_GREATER 3.4)
  option(OCPN_ENABLE_CLANG_TIDY "Add clang-tidy automatically to builds" OFF)
  set(ENABLE_SANITIZER "none" CACHE STRING "Add clang sanitizer to the build")
endif ()

if (CMAKE_VERSION VERSION_GREATER 3.9)
  option(OCPN_ENABLE_CPPCHECK "Add cppcheck automatically to builds" OFF)
endif ()

if (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set(
    CMAKE_BUILD_TYPE RelWithDebInfo
    CACHE
      STRING
      "Choose type of build: None Debug Release RelWithDebInfo MinSizeRel."
    FORCE
  )
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS
    "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)

if (APPLE)
  option(OCPN_USE_LIBCPP "Use libc++ instead of libstdc++ on macOS" ON)
endif ()

option(OCPN_USE_EXTERN_CURL "Use external libcurl" OFF)

if (NOT CMAKE_INSTALL_PREFIX)
  set(CMAKE_INSTALL_PREFIX ${TENTATIVE_PREFIX})
endif (NOT CMAKE_INSTALL_PREFIX)

if (NOT ${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
  set(BUNDLED_LIBS_DEFAULT "ON")
else ()
  set(BUNDLED_LIBS_DEFAULT "OFF")
endif ()
set(
  OCPN_USE_BUNDLED_LIBS ${BUNDLED_LIBS_DEFAULT}
  CACHE
    STRING
    "Use bundled libraries instead of system's [ON, OFF or comma-sep list]"
)

option(OCPN_USE_NEWSERIAL "Use new serial communication implementation" ON)
option(OCPN_USE_CURL "Use Curl libraries" ON)
option(OCPN_USE_SVG "Use SVG graphics" ON)
option(OCPN_USE_WEBVIEW "Use wxWidget's webview addon if available" ON)
option(OCPN_USE_LZMA "Use LZMA for chart compression" ON)
option(OCPN_CI_BUILD "Use CI build versioning rules" OFF)
option(OCPN_USE_SYSTEM_LIBARCHIVE "Use the libarchive version provided by the system on MacOS" ON)

option(
  OCPN_ENABLE_SYSTEM_CMD_SOUND
  "Use aplay(1), afplay(1) etc. to play sounds if available" ON
)

if (UNIX AND NOT APPLE AND NOT QT_ANDRIOD)
  set(LINUX "1")
endif ()

IF (QT_ANDROID)
  SET(OCPN_NEW_SERIAL OFF)
  SET(OCPN_USE_NEWSERIAL OFF)
  SET(OCPN_USE_CURL ON)
  SET(ENABLE_PORTAUDIO OFF)
  SET(ENABLE_SYSTEM_CMD_SOUND OFF)
  SET(ENABLE_SNDFILE OFF)
  SET(OCPN_USE_LZMA OFF)
ENDIF (QT_ANDROID)

# Check if a given library should use the bundled source
macro (USE_BUNDLED_LIB _result library)
  if ("${OCPN_USE_BUNDLED_LIBS}" STREQUAL "")
    set(OCPN_USE_BUNDLED_LIBS "ON")
  endif ()
  if (${OCPN_USE_BUNDLED_LIBS} STREQUAL "OFF")
    set(${_result} "OFF")
  elseif (${OCPN_USE_BUNDLED_LIBS} STREQUAL "ON")
    set(${_result} "ON")
  elseif (",${OCPN_USE_BUNDLED_LIBS}," MATCHES ",${library},")
    set(${_result} "ON")
  else ()
    set(${_result} "OFF")
  endif ()
endmacro (USE_BUNDLED_LIB)

#
# Language, compiler and static checkers setup
#

include(GetArch)
getarch()
message(STATUS "*** Host Build Architecture is ${ARCH}")

set(CMAKE_CXX_STANDARD 11)
message(STATUS "Setting C++11 standard via cmake standard mechanism")
if (NOT MSVC)
  set(OBJ_VISIBILITY "-fvisibility=hidden")
endif ()

if (CMAKE_VERSION VERSION_GREATER 3.4)
  if (OCPN_ENABLE_CLANG_TIDY)
    find_program(
      CLANG_TIDY_EXE
      NAMES "clang-tidy"
      PATHS /usr/local/opt/llvm/bin
    )
    if (CLANG_TIDY_EXE)
      message(STATUS "clang-tidy found: ${CLANG_TIDY_EXE}")
      # For more, see http://clang.llvm.org/extra/clang-tidy/
      # set(CLANG_TIDY_CHECKS "-*,modernize-*")
