=== debian/changelog ===
opencpn (5.6.0+dfsg1-1) unstable; urgency=medium

  * New upstream maintenance release
  * Update standards-version to 4.6.0, no changes.
  * Update compat-level to 13, drop override_dh_missing from d/rules.
  * Drop work-around for #831870 using zip download, clean up d/rules and
    d/watch

 -- Alec Leamas <leamas.alec@gmail.com>  Sat, 11 Dec 2021 21:05:00 +0100
