=== debian/rules ===
#!/usr/bin/make -f

include  /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	    -DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
	    -DCMAKE_INSTALL_PREFIX=/usr \
	    -DCMAKE_INSTALL_LIBDIR=/usr/lib \
            -DBUILD_SHARED_LIBS=OFF \
	    -DOCPN_BUNDLE_DOCS=OFF \
            -DOCPN_BUNDLE_TCDATA=ON \
            -DOCPN_USE_BUNDLED_LIBS=OFF \
            -DOCPN_USE_NEWSERIAL=OFF \
            -DOCPN_PLUGIN_CONTENTS_WARN=ON \
            -DOCPN_FORCE_GTK3=ON
